<div class="nr-grid">
  <div class="table-responsive">
    <table class="table {{options.bootstrapTableClass}} mb-0">
      <thead>
      <tr>
        <th *ngFor="let c of columns" class="nr-order-trigger" (click)="toggleOrder(c)"
            [ngClass]="{'text-right': c.alignment == 'right' }"
            [ngStyle]="{'width': c.width != undefined ? c.width : 'auto' }">

          <ng-container *ngTemplateOutlet="columnHeaderTemplate; context: {column: c}">

          </ng-container>
          <ng-container *ngIf="!columnHeaderTemplate">
            {{c.title}}
          </ng-container>
          <span class="nr-grid-orderer"
                *ngIf="order.column === (c.orderKey != null ? c.orderKey : c.name)">
                        <i *ngIf="!order.desc" class="mdi mdi-arrow-up-bold"></i>
                        <i *ngIf="order.desc" class="mdi mdi-arrow-down-bold"></i>
                    </span>
        </th>
        <th *ngIf="go.actionButtons"
            [ngStyle]="{'width': (90 + ((go.buttons ? go.buttons.length : 0) * 25)) + 'px' }"></th>
      </tr>
      <tr class="filter-row" *ngIf="go.filterRowEnabled">
        <td *ngFor="let c of columns">
          <ng-container *ngIf="!c.filterDisable">
            <input *ngIf="!c.filterType || isFilterDefault(c.filterType)" type="text" placeholder="Filter"
                   class="filter-control" [(ngModel)]="rowFilter[getFilterKey(c)]"
                   (ngModelChange)="filterChange()">
            <input *ngIf="isFilterDateRange(c.filterType)" type="text" class="btn-light-disable"
                   ngbDatepicker
                   #rangePicker="ngbDatepicker"
                   (dateSelect)="onDateSelection($event, getFilterKey(c))"
                   [dayTemplate]="dayTemplate"
                   [displayMonths]="2" outsideDays="visible" (focus)="rangePicker.toggle()"
                   [autoClose]="false"
                   placeholder="Filter"
                   [value]="rangeValue()"
                   class="filter-control">
            <div *ngIf="isFilterNumericRange(c.filterType)" class="range-selector">
              <input type="text" class="filter-control" placeholder="Grather"
                     [(ngModel)]="ranges[getFilterKey(c) + '___start']" (ngModelChange)="rangeChanged(c)">
              <input type="text" class="filter-control" placeholder="Lower"
                     [(ngModel)]="ranges[getFilterKey(c) + '___end']" (ngModelChange)="rangeChanged(c)">
            </div>

            <nr-select *ngIf="isFilterDropdown(c)" [(value)]="rowFilter[getFilterKey(c)]" [options]="c.selectOptions"
                       label="Select" (valueChange)="filterChange()"></nr-select>
            <div *ngIf="isFilterYesNo(c.filterType)" class="btn-group btn-group-toggle" ngbRadioGroup
                 name="radioBasic"
                 [(ngModel)]="rowFilter[getFilterKey(c)]" (ngModelChange)="filterChange()">
              <label ngbButtonLabel class="btn-primary btn-xs">
                <input ngbButton type="radio" [value]="true"> Yes
              </label>
              <label ngbButtonLabel class="btn-primary btn-xs">
                <input ngbButton type="radio" [value]="false"> No
              </label>
            </div>
          </ng-container>
        </td>
        <td *ngIf="go.actionButtons"></td>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let r of go.data; let rowIndex=index;"
          class="data-row"
          [ngClass]="{'nr-row-clickable': go.rowClickAction && go.rowClickAction.enable}"
          (click)="rowClicked(r)">
        <td *ngFor="let cr of columns"
            [ngClass]="{'text-right': cr.alignment == 'right', 'padding-none': editingRows['row-' + rowIndex + '-col-' + cr.name]}">

          <div *ngIf="cr.formatter && !isLinkCell(cr.type)">
            {{r[cr.name]|valueFormat: cr.formatter}}
          </div>

          <div class="default-view"
               *ngIf="!cr.formatter && isDefaultCell(cr.type) && !editingRows['row-' + rowIndex + '-col-' + cr.name]"
               [innerHTML]="cr.format ? cr.format({row: r, value: r[cr.name], parent: go.parent }) : r[cr.name]"
               (click)="inlineEditorOn(cr, rowIndex, r)"></div>

          <div *ngIf="isLinkCell(cr.type)">
            <a href="javascript:void(0)" (click)="linkClicked({row: r, column: cr})"
               class="{{cr.link && cr.link.classes ? cr.link.classes : ''}}"
               [ngbTooltip]="cr.link && cr.link.tooltip ? cr.link.tooltip : ''">
              <i *ngIf="cr.link && cr.link.icon" class="{{cr.link.icon}}"></i>

              <span *ngIf="!cr.formatter"
                    [innerHTML]="cr.format ? cr.format({row: r, value: r[cr.name], parent: go.parent}) : r[cr.name]"></span>
              <span *ngIf="cr.formatter">{{r[cr.name]|valueFormat: cr.formatter}}</span>
            </a>
          </div>
          <div *ngIf="editingRows['row-' + rowIndex + '-col-' + cr.name]">
            <div class="nr-inline-editor">
              <input [id]="'row-' + rowIndex + '-col-' + cr.name" type="text" [(ngModel)]="r[cr.name]"/>
              <div class="nr-inline-editor-buttons">
                <button class="btn btn-sm btn-primary" type="button" (click)="inlineEditorOff(cr, rowIndex, r, true)">
                  Save
                </button>
                <button class="btn btn-sm btn-secondary" type="button"
                        (click)="inlineEditorOff(cr, rowIndex, r, false, true)">Cancel
                </button>
              </div>
            </div>
          </div>
        </td>
        <td class="action-buttons-container" *ngIf="go.actionButtons">
          <ng-container *ngFor="let b of go.buttons">
            <a href="javascript:void(0);" (click)="customButtonClick(b, r)" ngbTooltip="{{b.tooltip}}"
               *ngIf="!b.visible || (b.visible && b.visible(r))">
              <i class="{{b.icon}}"></i>
            </a>
          </ng-container>
          <a href="javascript:void(0);" (click)="editClicked(r)" ngbTooltip="Edit"
             *ngIf="!go.actionButtonsOptions || checkEditButtonOption(r)">
            <i class="fa fa-pencil"></i>
          </a>
          <a href="javascript:void(0);" (click)="deleteClicked(r)" ngbTooltip="Delete"
             *ngIf="!go.actionButtonsOptions || checkDeleteButtonOption(r)">
            <i class="fa fa-trash"></i>
          </a>
        </td>
      </tr>
      <tr *ngIf="go.data == undefined || go.data.length == 0">
        <td [colSpan]="columns.length + (go.actionButtons ? 1 : 0)">
          <div style="padding: 20px; text-align: center">
            No data
          </div>
        </td>
      </tr>
      </tbody>
      <tfoot *ngIf="go.summary && !go.hideSummary">
      <tr>
        <th *ngFor="let cr of columns" [ngClass]="{'text-right': cr.alignment == 'right' }">
          <ng-container *ngIf="!cr.hideFromSummary">
            <div *ngIf="cr.formatter">
              {{go.summary[cr.name]|valueFormat: cr.formatter}}
            </div>

            <div *ngIf="isDefaultCell(cr.type) && (!cr.formatter)"
                 [innerHTML]="cr.format ? cr.format({row: go.summary, value: go.summary[cr.name], parent: go.parent}) : go.summary[cr.name]"></div>

            <div *ngIf="isLinkCell(cr.type) && (!cr.formatter)">
              <a href="javascript:void(0)" (click)="linkClicked({row: go.summary, column: cr})"
                 class="{{cr.link.classes ? cr.link.classes : ''}}"
                 [ngbTooltip]="cr.link && cr.link.tooltip ? cr.link.tooltip : ''">
                <i *ngIf="cr.link.icon" class="{{cr.link.icon}}"></i>
                <span
                  [innerHTML]="cr.format ? cr.format({row: go.summary, value: go.summary[cr.name], parent: go.parent}) : go.summary[cr.name]"></span>
              </a>
            </div>
          </ng-container>
        </th>
      </tr>
      </tfoot>
    </table>

  </div>
  <ng-container *ngTemplateOutlet="footerTemplate;">

  </ng-container>
  <div class="nr-grid-footer row" *ngIf="go.pager">
    <div class="col-md-12">
      <ngb-pagination class="float-right" [collectionSize]="go.rowCount" [(page)]="go.page" [maxSize]="10"
                      [pageSize]="go.limit" (pageChange)="pageChange($event)"></ngb-pagination>
      <div class="float-right limit-selector" style="min-width: 150px; width: 150px">
        <nr-select class="float-right" [data]="pages" [(value)]="go.limit" label="Limit" [options]="limitChangeOptions"
                   (valueChange)="limitChanged($event)"></nr-select>
      </div>
    </div>
  </div>
  <div class="clearfix"></div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">Delete</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    Data will be deleted, are you sure?
  </div>
  <div class="modal-footer">
    <button type="submit" class="btn btn-success" (click)="submitDelete()">Delete</button>
    <button type="button" class="btn btn-secondary" (click)="modal.dismiss('Cross click')">Cancel</button>
  </div>
</ng-template>
<ng-template #dayTemplate let-date let-focused="focused">
  <span class="custom-day"
        [class.focused]="focused"
        [class.range]="isRange(date)"
        [class.faded]="isHovered(date) || isInside(date)"
        (mouseenter)="hoveredDate = date"
        (mouseleave)="hoveredDate = null">
    {{ date.day }}
  </span>
</ng-template>
